﻿function cuepoint(p_param) {
    setContent(p_param);
}

function start(p_param) {
    setContent();
}

function seek(p_param) {
    setContent(p_param);
}

function end(p_param) {
}

function play(p_param) {
}

function pause(p_param) {
}

function custom(p_param) {
    var paramArray = p_param.split(",");
    if (paramArray[0] == "setMode") {
        mode = paramArray[1];
    }
}

var mode = "viewer";
var linkUrl;
var linkTarget;
var linkPasswordAutoInput = false;

var linkUserInfoAutoInput = false;

function setContent(p_param) {
    var xotree = new XML.ObjTree();
    var xml = p_param;
    var param = xotree.parseXML(xml);
    var htmlStr = "";

    try {

        var rpath = param.param.unit.rpath;
        var url = linkUrl = param.param.cue.cueData.url;
        var target = linkTarget = param.param.cue.cueData.linkTarget;

        if(param.param.cue.cueData.passwordAutoInput == "true"){
           linkPasswordAutoInput = true;
        }else{
           linkPasswordAutoInput = false;
        }

 		if(param.param.cue.cueData.userInfoAutoInput == "true"){
           linkUserInfoAutoInput = true;
        }else{
           linkUserInfoAutoInput = false;
        }

        if (url == null || url == "" || url == undefined) {
            htmlStr = "<img src='./data/" + rpath + "' border=0>";
        } else {
            htmlStr = "<a href='javascript:linkOpen();'><img src='./data/" + rpath + "' border=0></a>";
        }

    } catch (e) {

    }

    var mda = document.getElementById("content");
    mda.innerHTML = htmlStr;

}

function linkOpen() {
	
    var url = linkUrl;
    var target = linkTarget;
	
    var searchParam = getParentParam();
	
    var passwordAutoInput = linkPasswordAutoInput;
    if(passwordAutoInput){
 		
        var passwordhash = searchParam["h"];
        if(passwordhash != null && passwordhash != "" && passwordhash != undefined) {
            url = addParam(url,passwordhash);
        }
 	}
 	
 	//※1.12.2
 	var userInfoAutoInput = linkUserInfoAutoInput;
    if(userInfoAutoInput){
        
        var userInfo = "";
    	try{
	        userInfo = window.parent.thisMovie("mainLayer").external_getGaeUserName();
	    }catch(e){
	    	
	    }
	    
        if(userInfo != null && userInfo != "" && userInfo != undefined) {
            url = addParamUserInfo(url,userInfo);
        }
 	}
 	
    switch (target) {
        case "_self":
            if (mode == "viewer") {
                window.open(url, "_parent");
            } else {
                window.open(url, "_blank");
            }
            break;
        case "_blank":
        default:
            window.open(url, "_blank");
            break;
    }

}

function getParentParam() {
	if (window != window.parent) {
		var _parent = window.parent;
	    if (_parent.location.search.length > 1) {
	        var get = new Object();
	        var ret = _parent.location.search.substr(1).split("&");
	        for (var i = 0; i < ret.length; i++) {
	            var r = ret[i].split("=");
	            get[r[0]] = r[1];
	        }
	        return get;
	    } else {
	        return false;
	    }
	}else{
		return false;
	}
}

function addParam(url, passwordhash) {

    var tmpUrl = url;
    var tmpPasswordHash = passwordhash;

    var exist_serach = (tmpUrl.indexOf("?") > 0);
    var exist_hash = (tmpUrl.indexOf("#") > 0);

    var nowtime = String(new Date().getTime());
    var keytime = base64encodeURI(nowtime);

    var addParamStr = "?h=" + tmpPasswordHash + "&k=" + keytime;

    if (exist_serach) {
        //※?が存在
        tmpUrl = tmpUrl.split("?").join(addParamStr + "&");
    } else {
        //※?が存在しない
        if (exist_hash) {
            //※#が存在
            tmpUrl = tmpUrl.split("#").join(addParamStr + "#");
        } else {
            //※#が存在しない
            tmpUrl = tmpUrl + addParamStr;
        }
    }

    return tmpUrl;
}

//※1.12.2
function addParamUserInfo(url, userInfo) {

	var tmpUrl = url;
	var tmpUserInfo = userInfo;

	var exist_serach = (tmpUrl.indexOf("?") > 0);
    var exist_hash = (tmpUrl.indexOf("#") > 0);

	var addParamStr = "?u=" + encodeURIComponent(tmpUserInfo);

	if (exist_serach) {
		//※?が存在
		tmpUrl = tmpUrl.split("?").join(addParamStr + "&");
    } else {
    	//※?が存在しない
    	if (exist_hash) {
    		//※#が存在
    		tmpUrl = tmpUrl.split("#").join(addParamStr + "#");
    	} else {
    		//※#が存在しない
    		tmpUrl = tmpUrl + addParamStr;
    	}
    }

	return tmpUrl;

}

//※1.12.2

/* Copyright (C) 1999 Masanao Izumo <iz@onicos.co.jp>
 * Version: 1.0
 * LastModified: Dec 25 1999
 * This library is free.  You can redistribute it and/or modify it.
 */

/*
 * Interfaces:
 * b64 = base64encode(data);
 * data = base64decode(b64);
 */


var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
var base64DecodeChars = new Array(
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
    -1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
    -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1);

function base64encode(str) {
    var out, i, len;
    var c1, c2, c3;

    len = str.length;
    i = 0;
    out = "";
    while(i < len) {
	c1 = str.charCodeAt(i++) & 0xff;
	if(i == len)
	{
	    out += base64EncodeChars.charAt(c1 >> 2);
	    out += base64EncodeChars.charAt((c1 & 0x3) << 4);
	    out += "==";
	    break;
	}
	c2 = str.charCodeAt(i++);
	if(i == len)
	{
	    out += base64EncodeChars.charAt(c1 >> 2);
	    out += base64EncodeChars.charAt(((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4));
	    out += base64EncodeChars.charAt((c2 & 0xF) << 2);
	    out += "=";
	    break;
	}
	c3 = str.charCodeAt(i++);
	out += base64EncodeChars.charAt(c1 >> 2);
	out += base64EncodeChars.charAt(((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4));
	out += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6));
	out += base64EncodeChars.charAt(c3 & 0x3F);
    }
    return out;
}

function base64decode(str) {
    var c1, c2, c3, c4;
    var i, len, out;

    len = str.length;
    i = 0;
    out = "";
    while(i < len) {
	/* c1 */
	do {
	    c1 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
	} while(i < len && c1 == -1);
	if(c1 == -1)
	    break;

	/* c2 */
	do {
	    c2 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
	} while(i < len && c2 == -1);
	if(c2 == -1)
	    break;

	out += String.fromCharCode((c1 << 2) | ((c2 & 0x30) >> 4));

	/* c3 */
	do {
	    c3 = str.charCodeAt(i++) & 0xff;
	    if(c3 == 61)
		return out;
	    c3 = base64DecodeChars[c3];
	} while(i < len && c3 == -1);
	if(c3 == -1)
	    break;

	out += String.fromCharCode(((c2 & 0XF) << 4) | ((c3 & 0x3C) >> 2));

	/* c4 */
	do {
	    c4 = str.charCodeAt(i++) & 0xff;
	    if(c4 == 61)
		return out;
	    c4 = base64DecodeChars[c4];
	} while(i < len && c4 == -1);
	if(c4 == -1)
	    break;
	out += String.fromCharCode(((c3 & 0x03) << 6) | c4);
    }
    return out;
}

//---
function base64encodeURI(str) {
    var encodedStr = base64encode(str);
    var replacedStr = encodedStr.replace(/\+/g, '-').replace(/\//g, '_').replace(/\=+$/, '');
    return replacedStr;
}

//---
function base64decodeURI(str) {
    var slicedStr = (str + '===').slice(0, str.length + (str.length % 4));
    var replacedStr = slicedStr.replace(/-/g, '+').replace(/_/g, '/');
    var decodedStr = base64decode(replacedStr);
    return decodedStr;
}